'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' FreeImage library demo using freeimage.dll,
' and xfi.dll, a wrapper for calling functions
' in freeimage. It also calls upon helper functions
' in the xfree library. Both xfi and xfree provided
' by Ken Minogue.
' http://freeimage.sourceforge.net/index.html
'
'	The program requires the custom canvas control
' canvas.dll to display the images.
'
PROGRAM	"fitest"
VERSION	"0.0001"
'
	IMPORT	"xst"   		' standard library 	: required by most programs
	IMPORT  "xsx"
'	IMPORT	"xio"				' console IO library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT	"kernel32"	' kernel32.dll
	IMPORT  "canvas"		' canvas.dll 				: canvas control
	IMPORT	"xbm"				' xbm.dll 					: bitmap library
	IMPORT  "xfi"				' free image wrapper library
	IMPORT  "xfree"			' free image helper library
	IMPORT  "comctl32.dec"
  IMPORT  "comdlg32"	' comdlg32.dll			: common dialog library
'
DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  WndProc (hwnd, msg, wParam, lParam)
DECLARE FUNCTION  InitGui ()
DECLARE FUNCTION  RegisterWinClass (className$, addrWndProc, icon$, menu$)
DECLARE FUNCTION  CreateWindows ()
DECLARE FUNCTION  NewWindow (className$, title$, style, x, y, w, h, exStyle)
DECLARE FUNCTION  MessageLoop ()
DECLARE FUNCTION  CleanUp ()
DECLARE FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION  ShowOpenFileDialog (hWndOwner, @fileName$, filter$, initDir$, title$)
DECLARE FUNCTION  ShowSaveFileDialog (hWndOwner, @fileName$, filter$, initDir$, title$)
'
' Control IDs
'
$$CC_CANVAS1 = 100
'
' Menu IDs
'
$$CM_FILE_OPEN = 101
$$CM_FILE_CLOSE = 102
$$CM_FILE_SAVEAS = 103
$$CM_FILE_EXIT = 104
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	STATIC	entry
'
	IF entry THEN RETURN					' enter once
	entry =  $$TRUE								' enter occured

'	XioCreateConsole (title$, 50)	' create console, if console is not wanted, comment out this line
	InitGui ()										' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create main windows and other child controls
	MessageLoop ()								' the message loop
	CleanUp ()										' unregister all window classes
'	XioFreeConsole ()							' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION  WndProc (hWnd, msg, wParam, lParam)
'
	SHARED hInst
	RECT rect
	STATIC UBYTE image[], destImage[]
	STATIC selectedFile$, currentPath$, hImage, bpp, hCanvas1
	STATIC imageWidth, imageHeight
	DOUBLE degrees
'
	SELECT CASE msg
'
		CASE $$WM_CREATE :
			GetClientRect (hWnd, &rect)
			hCanvas1 = NewChild ($$CANVASCLASSNAME, "", style, 0, 0, rect.right, rect.bottom, hWnd, $$CC_CANVAS1, 0)

		CASE $$WM_DESTROY :
			XbmDeleteMemBitmap (hImage)
			PostQuitMessage(0)

		CASE $$WM_SIZE :
			width = LOWORD(lParam)
			height = HIWORD (lParam)
			SetWindowPos (hCanvas1, 0, 0, 0, width, height, $$SWP_NOZORDER)

		CASE $$WM_COMMAND :
			id         = LOWORD(wParam)
			hwndCtl    = lParam
			notifyCode = HIWORD(wParam)
			SELECT CASE id
				CASE $$CM_FILE_OPEN 				:	filter$ = "Any Image File (*.*)" + CHR$(0) + "*.*" + CHR$(0) + CHR$(0)
																			IF ShowOpenFileDialog (hWnd, @file$, filter$, currentPath$, "Open an Image File") THEN
																				IF file$ THEN
																					currentPath$ = LEFT$ (file$, RINSTR (file$, "\\"))
																					selectedFile$ = file$
																				GOSUB LoadImage
																				END IF
																			END IF

				CASE $$CM_FILE_CLOSE 				:	DIM image[]
																			XbmDeleteMemBitmap (hImage)
																			hImage = 0
																			SendMessageA (hCanvas1, $$WM_CLEAR_CANVAS_IMAGE, 0, 0)
																			selectedFile$ = ""
																			currentPath$ = ""

				CASE $$CM_FILE_SAVEAS 			: IFZ image[] THEN RETURN
																			filter$ = "Image Files (*.bmp, *.jpg, *.gif, *.png)" + CHR$(0) + "*.bmp;*.jpg;*.gif;*.png" + CHR$(0) + CHR$(0)
																			file$ = ""
																			IF ShowSaveFileDialog (hWnd, @file$, filter$, currentPath$, "Save File As Image File") THEN
																				chk$ = RIGHT$(UCASE$(file$),4)
																				SELECT CASE chk$
																					CASE ".BMP" : fif = $$FIF_BMP
																					CASE ".JPG" : fif = $$FIF_JPEG
																					CASE ".GIF" : fif = $$FIF_GIF : flag = 0
																					CASE ".PNG" : fif = $$FIF_PNG
																					CASE ELSE   : RETURN
																				END SELECT
																				IF XfiSaveFile (fif, file$, @image[], flag) THEN
																					XstAlert (XfiOutputMessage$ ())
																				END IF
																			END IF

				CASE $$CM_FILE_EXIT 				:	DestroyWindow (hWnd)
			END SELECT

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT


' ***** LoadImage *****
SUB LoadImage
	IFZ selectedFile$ THEN EXIT SUB
	DIM image[]
	XfiLoadFile (-1, @selectedFile$, @image[])
	IFZ image[] THEN EXIT SUB
	XfiVersion (@xfiVersion$, @fiVersion$, @copyright$)
	text$ = "FreeImage " + fiVersion$ + " - [" + selectedFile$ + "]"
	SetWindowTextA (hWnd, &text$)
	GOSUB DisplayImage
END SUB
'
' ***** SUB DisplayImage *****
SUB DisplayImage
'
' display image in hCanvas1
	IF hImage THEN XbmDeleteMemBitmap (hImage)										' delete last memory bitmap
	XbmGetImageArrayInfo (@image[], @bpp, @imageWidth, @imageHeight)
	IF bpp < 8 THEN MessageBoxA (hWnd, &"Currently loaded image bitsperpixel is < 8.\nTransformations and filters not available.\nPlease load an 8-bit or 24-bit image.", &"Warning", $$MB_OK | $$MB_ICONEXCLAMATION)
	IFZ imageWidth * imageHeight THEN EXIT SUB
	IF bpp = 8 THEN XbmDIBto24Bit (@image[])											' convert to 24bpp (1-bit and 4-bit conversions not currently working in XbmDIBto24Bit)
	XbmCreateMemBitmap (hWnd, imageWidth, imageHeight, @hImage)		' create memory bitmap
	XbmSetImage (hImage, @image[])																' set image array into memory bitmap
	SendMessageA (hCanvas1, $$WM_SET_CANVAS_IMAGE, 0, hImage)			' display memory bitmap in canvas control
'
END SUB
'
END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION  InitGui ()

	SHARED hInst
	hInst = GetModuleHandleA (0)	' get current instance handle
	IFZ hInst THEN QUIT(0)

END FUNCTION
'
'
' #################################
' #####  RegisterWinClass ()  #####
' #################################
'
FUNCTION  RegisterWinClass (className$, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc

	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN ($$TRUE)

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION  CreateWindows ()

	SHARED className$, hInst

' register window class
	className$  = "FreeImageLibraryDemo"
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= "menu"
	IF RegisterWinClass (@className$, addrWndProc, @icon$, @menu$) THEN RETURN ($$TRUE)

' create main window
	title$  		= "FreeImage Library Demo."
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 500
	h 					= 350
	#winMain = NewWindow (className$, title$, style, x, y, w, h, 0)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION  NewWindow (className$, title$, style, x, y, w, h, exStyle)

	SHARED hInst

	RETURN CreateWindowExA (exStyle, &className$, &title$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION  MessageLoop ()

	STATIC USER32_MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN			' main program executes message loop

	DO
		ret = GetMessageA (&msg, 0, 0, 0)

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam
			CASE -1 : RETURN $$TRUE
			CASE ELSE:
				IFZ IsDialogMessageA (#winMain, &msg) THEN
  				TranslateMessage (&msg)
  				DispatchMessageA (&msg)
				END IF
		END SELECT
	LOOP

END FUNCTION
'
'
' ########################
' #####  CleanUp ()  #####
' ########################
'
FUNCTION  CleanUp ()

	SHARED hInst, className$

	UnregisterClassA(&className$, hInst)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

' create child control
	style = style | $$WS_CHILD | $$WS_VISIBLE
	hwnd = CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)
	RETURN hwnd

END FUNCTION
'
'
' ###################################
' #####  ShowOpenFileDialog ()  #####
' ###################################
'
FUNCTION  ShowOpenFileDialog (hWndOwnder, @fileName$, filter$, initDir$, title$)

	OPENFILENAME ofn
	SHARED hInst

	ofn.lStructSize = LEN(ofn)				'set length of struct
	ofn.hwndOwner 	= hWndOwner				'set parent window handle
	ofn.hInstance 	= hInst						'set the application's instance

'select a filter
'pstrFilter points to a buffer containing pairs of null-terminated
'filter strings. The first string in each pair describes a filter
'(for example, "Text Files"), and the second specifies the
'filter pattern (for example, "*.TXT"). Multiple filters can be
'specified for a single item by separating the filter pattern strings
'with a semicolon (for example, "*.TXT;*.DOC;*.BAK"). The last string
'in the buffer must be terminated by two NULL characters. If this member
'is NULL, the dialog box will not display any filters.
'The filter strings are assumed to be in the proper order - the
'operating system does not change the order.

'	filter$ = "XB Files (*.x, *.dec)" + CHR$(0) + "*.x;*.dec" + CHR$(0) + "Text Files (*.txt)" + CHR$(0) + "*.txt" + CHR$(0) + "All Files (*.*)" + CHR$(0) + "*.*" + CHR$(0) + CHR$(0)
	ofn.lpstrFilter = &filter$

'create a buffer for the returned file
	IF fileName$ = "" THEN
		fileName$ = SPACE$(254)
	ELSE
		fileName$ = fileName$ + SPACE$(254 - LEN(fileName$))
	END IF
	ofn.lpstrFile 			= &fileName$

	ofn.nMaxFile 				= 255					'set the maximum length of a returned file

	buffer2$ = SPACE$(254)
	ofn.lpstrFileTitle 	= &buffer2$		'Create a buffer for the file title
	ofn.nMaxFileTitle 	= 255					'Set the maximum length of a returned file title
	ofn.lpstrInitialDir = &initDir$		'Set the initial directory
  ofn.lpstrTitle 			= &title$			'Set the title
  ofn.flags = $$OFN_FILEMUSTEXIST OR $$OFN_PATHMUSTEXIST OR $$OFN_EXPLORER	'flags

'call dialog
	IFZ GetOpenFileNameA (&ofn) THEN
		fileName$ = ""
		RETURN 0
	ELSE
		fileName$ = CSTRING$(ofn.lpstrFile)
		RETURN $$TRUE
	END IF

END FUNCTION
'
'
' ###################################
' #####  ShowSaveFileDialog ()  #####
' ###################################
'
FUNCTION  ShowSaveFileDialog (hWndOwner, @fileName$, filter$, initDir$, title$)

	OPENFILENAME ofn
	SHARED hInst

	ofn.lStructSize = LEN(ofn)			'set length of struct
	ofn.hwndOwner 	= hWndOwner			'set parent window handle
	ofn.hInstance 	= hInst					'set the application's instance

'select a filter
'pstrFilter points to a buffer containing pairs of null-terminated
'filter strings. The first string in each pair describes a filter
'(for example, "Text Files"), and the second specifies the
'filter pattern (for example, "*.TXT"). Multiple filters can be
'specified for a single item by separating the filter pattern strings
'with a semicolon (for example, "*.TXT;*.DOC;*.BAK"). The last string
'in the buffer must be terminated by two NULL characters. If this member
'is NULL, the dialog box will not display any filters.
'The filter strings are assumed to be in the proper order - the
'operating system does not change the order.

'	filter$ = "XB Files (*.x, *.dec)" + CHR$(0) + "*.x;*.dec" + CHR$(0) + "Text Files (*.txt)" + CHR$(0) + "*.txt" + CHR$(0) + "All Files (*.*)" + CHR$(0) + "*.*" + CHR$(0) + CHR$(0)
	ofn.lpstrFilter = &filter$

'create a buffer for the returned file
	IF fileName$ = "" THEN
		fileName$ = SPACE$(254)
	ELSE
		fileName$ = fileName$ + SPACE$(254 - LEN(fileName$))
	END IF
	ofn.lpstrFile 			= &fileName$

	ofn.nMaxFile 				= 255					'set the maximum length of a returned file
	buffer2$ = SPACE$(254)
	ofn.lpstrFileTitle 	= &buffer2$		'Create a buffer for the file title
	ofn.nMaxFileTitle 	= 255					'Set the maximum length of a returned file title
	ofn.lpstrInitialDir = &initDir$		'Set the initial directory
  ofn.lpstrTitle 			= &title$			'Set the title
  ofn.flags = $$OFN_PATHMUSTEXIST OR $$OFN_EXPLORER	'flags

'call dialog
	IFZ GetSaveFileNameA (&ofn) THEN
		fileName$ = ""
		RETURN 0
	ELSE
		fileName$ = CSTRING$(ofn.lpstrFile)
		RETURN $$TRUE
	END IF

END FUNCTION

END PROGRAM
